Skip to content
Start here

Upload a schema

POST/zones/{zone_id}/schema_validation/schemas

Uploads a new OpenAPI schema for API Shield schema validation. The schema defines expected request/response formats for API endpoints.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Account API GatewayDomain API Gateway
Path ParametersExpand Collapse
zone_id: string

Identifier.

maxLength32
Body ParametersJSONExpand Collapse
kind: "openapi_v3"

The kind of the schema

name: string

A human-readable name for the schema

source: string

The raw schema, e.g., the OpenAPI schema, either as JSON or YAML

validation_enabled: boolean

An indicator if this schema is enabled

ReturnsExpand Collapse
errors: array of { code, message, documentation_url, source }
code: number

A unique error code that describes the kind of issue with the schema

minimum1000
message: string

A short text explaining the issue with the schema

documentation_url: optional string
source: optional { locations, pointer }
locations: optional array of string

A list of JSON path expression(s) that describe the location(s) of the issue within the provided resource. See https://goessner.net/articles/JsonPath/ for JSONPath specification.

pointer: optional string
messages: array of { code, message, documentation_url, source }
code: number

A unique error code that describes the kind of issue with the schema

minimum1000
message: string

A short text explaining the issue with the schema

documentation_url: optional string
source: optional { locations, pointer }
locations: optional array of string

A list of JSON path expression(s) that describe the location(s) of the issue within the provided resource. See https://goessner.net/articles/JsonPath/ for JSONPath specification.

pointer: optional string
result: PublicSchema { created_at, kind, name, 3 more }

A schema used in schema validation

created_at: string
formatdate-time
kind: "openapi_v3"

The kind of the schema

name: string

A human-readable name for the schema

schema_id: string

A unique identifier of this schema

maxLength36
minLength36
formatuuid
source: string

The raw schema, e.g., the OpenAPI schema, either as JSON or YAML

validation_enabled: optional boolean

An indicator if this schema is enabled

success: true

Whether the API call was successful.

Upload a schema

curl https://api.cloudflare.com/client/v4/zones/$ZONE_ID/schema_validation/schemas \
    -H 'Content-Type: application/json' \
    -H "Authorization: Bearer $CLOUDFLARE_API_TOKEN" \
    -d '{
          "kind": "openapi_v3",
          "name": "petstore schema",
          "source": "<schema file contents>",
          "validation_enabled": true
        }'
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "locations": [
          ".paths[\"/user/{username}\"].put"
        ],
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "locations": [
          ".paths[\"/user/{username}\"].put"
        ],
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "created_at": "2014-01-01T05:20:00.12345Z",
    "kind": "openapi_v3",
    "name": "petstore schema",
    "schema_id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415",
    "source": "<schema file contents>",
    "validation_enabled": true
  },
  "success": true
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "locations": [
          ".paths[\"/user/{username}\"].put"
        ],
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "locations": [
          ".paths[\"/user/{username}\"].put"
        ],
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "created_at": "2014-01-01T05:20:00.12345Z",
    "kind": "openapi_v3",
    "name": "petstore schema",
    "schema_id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415",
    "source": "<schema file contents>",
    "validation_enabled": true
  },
  "success": true
}